<?php
/*

BBS Netaxept Payment Module 0.9 BETA for Zen Cart 1.3.8, developed by BBS AS.
This module uses the WebService API developed by BBS. 
BBS will not provide any official support on this module.
We appreciate if you contact us about errors or future improvments on this module. 

BBS AS
Haavard Martinsens Vei 54
0978 Oslo
Norway
kundeservice@netaxept.no

Check the documentation on www.netaxept.no for further information.
Errors may occur. Use at your own risk.

Released under the GNU General Public License
*/

//  include('includes/application_top.php');
require(DIR_FS_CATALOG.'SetupRequestClass.php');

class netaxept_bbs {
	var $code, $title, $description, $enabled;

	// class constructor
    function netaxept_bbs() {
		global $order;
	
		$this->code = 'netaxept_bbs';
		$this->title = MODULE_PAYMENT_BBS_NETAXEPT_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_BBS_NETAXEPT_TEXT_DESCRIPTION;
		$this->sort_order = MODULE_PAYMENT_BBS_NETAXEPT_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_BBS_NETAXEPT_STATUS == 'True') ? true : false);
	
		if ((int)MODULE_PAYMENT_BBS_NETAXEPT_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_BBS_NETAXEPT_ORDER_STATUS_ID;
		}
	
		if (is_object($order)) $this->update_status();
	}

	// class methods
	function update_status() {
    	global $order;

      	if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_BBS_NETAXEPT_ZONE > 0) ) {
			$check_flag = false;
				
			$check = $db->Execute("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . 
				MODULE_PAYMENT_BBS_NETAXEPT_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        
			while (!$check->EOF){ 
				if ($check['zone_id'] < 1) {
				    $check_flag = true;
				    break;
				} 
				elseif ($check['zone_id'] == $order->delivery['zone_id']) {
					$check_flag = true;
				   	break;
				}
	
				$check->MoveNext();
			}
	
			if ($check_flag == false) {
				$this->enabled = false;
			}
		}

		// disable the module if the order only contains virtual products
	    if ($this->enabled == true) {
			if ($order->content_type == 'virtual') {
				$this->enabled = false;
			}
	    }
    }

	function javascript_validation() {
		return false;
	}

    function selection() {
       	return array('id' => $this->code,
        			'module' => $this->title);
    }

    function pre_confirmation_check() {
    	return false;
    }

    function confirmation() {
       	return false;
    }

    function process_button() {
       	return false;
    }

    function before_process() {
		return false;
    }

	########
	/*
	BBS Netaxept payment process:


	1. Setup
		The setup call in netaxept_bbs.php in the function after_process initiates the payment process.

		Returns a form input field, BBSePay_transaction string used in the ProcessSetup call.
		Redirects the user to the terminal via checkout_redirect_netaxept_bbs.php.

	2. ProcessSetup
		Called from checkout_success_netaxept_bbs.php when the customer has returned from the terminal.
		If ResponseCode is OK, then auth or sale is called.

	3. Auth or Sale
		Called from checkout_success_netaxept_bbs.php if ResponseCode from ProcessSetup was OK.
		Do an auth to reserve the money on the customers card and later in Netaxept Backoffice capture the money.
		Do a sale to capture the money at once. (Please follow your country laws when doing a capture, e.g. in Norway; dont capture the money if you dont have the item in stock. Do a capture when you send the package to the customer).

	The payment process is finished!

	*/

	function after_process() 
	{
		// after processing the order id is created and available as the global $insert_id
		global $insert_id;
		global $HTTP_POST_VARS;
		global $order;

		$ret = false;
		
		if ($order && $insert_id) {
		
			// merchant id for your account at Netaxept, set via admin page
		    $merchantId = MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID;
		    // Token for your account at Netaxept, set via admin page
		    $token = MODULE_PAYMENT_BBS_NETAXEPT_TOKEN;
		    // the order id number
		    $orderNumber = $insert_id;
		    // language code for language to use at Netaxept Terminal, set via admin page
		    $language = MODULE_PAYMENT_BBS_NETAXEPT_LANGUAGE;
		    // currency used, dynamic, from osCommerce
		    $currencyCode = $order->info['currency'];
		    // order total amount, dynamic, from osCommerce
		    $amount = $order->info['total']*100;
		    // Redirect from Netaxept to checkout successful page
		    if (MODULE_PAYMENT_BBS_NETAXEPT_DEBUG == "Normal") {
		    	$redirect_url = HTTP_SERVER . DIR_WS_CATALOG . "checkout_success_netaxept_bbs.php";
		    }	
		    else {
		    	$redirect_url = HTTP_SERVER . DIR_WS_CATALOG . "checkout_success_netaxept_bbs_debug.php";
		    }	        
		        	                          
		    $customerPhoneNumber = $order->customer['telephone'];
		    $customerEmail = $order->customer['email_address'];
		    $description = $order->info['comments'];
			$serviceType = 'B';

            $transactionId = urlencode(md5(uniqid()));
            $sessionId = $transactionId;

		    ######################################################
		    // Generate order description

		    $order_desc = "<div align='left' valign='top'>";
		    $oder_desc_temp = "";
		    for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
				$order_desc_temp .= $order->products[$i]['qty'];
		        $order_desc_temp .= " x ";
		        $order_desc_temp .= $order->products[$i]['name'];

		        if (strlen($order_desc) > 1400) {
		        	break;
				} else {
		        	$order_desc .= $order_desc_temp;
		            $order_desc_temp = "";
		            $order_desc .= "<br/>";
		        }
		 	}

		    if (strlen($order_desc) <= 1400) {
		    	$order_desc .= "<br/>";
		        $order_desc .= "</div>";
		    }
		    else {
		    	$order_desc = substr($order_desc,0,1400);
		        $order_desc .= "<br/>";
		        $order_desc .= "<small>...(order description cut to fit terminal)</small>";
		        $order_desc .= "<br/>";
		        $order_desc .= "</div>";
			}

		    
	        $cur_encoding = mb_detect_encoding($order_desc) ;
            if($cur_encoding == "UTF-8" && mb_check_encoding($order_desc,"UTF-8"))
        	  	$orderDescription = $order_desc;
            else
            	$orderDescription = utf8_encode($order_desc);

	        ######################################################

            $cur_encoding = mb_detect_encoding($description) ;
            if($cur_encoding == "UTF-8" && mb_check_encoding($description,"UTF-8"))
        	 	$description_enc = $description;
            else
            	$description_enc = utf8_encode($description);
	
	        $description = $description_enc;	        

	        
			####  START SETUP  ####

			$setupRequest = new SetupRequest
			(
				$amount,
				$currencyCode,
				$customerEmail,
				$customerPhoneNumber,
				$description,
				$language,
				$orderDescription,
				$orderNumber,

				$PanHash,                     /* PanHash == Personal Account Number HASH */                               
				$RecurringExpiryDate,         /* Subscription expiry date               */                               
				$RecurringFrequency,          /* number of days between captures         */                               
				$RecurringType,               /* S: store ; R: Recurring                 */                               
						                                                                                             
				$redirect_url,                                                                                              
				$serviceType,                  /* B : BBS Hosted UI ; M : Merchant Hosted UI ; C : Call Center Solution */ 
				$sessionId,
				$transactionId
			) ;

			$params_transaction = array
			(
				"token"                 => "$token",
				"merchantId"            => "$merchantId",
				"request"               => $setupRequest
			);

			
            // WSDL location found in documentation
            $wsdl = MODULE_PAYMENT_BBS_NETAXEPT_WSDLLOCATION;
                        
			try 
			{
				$client = new SoapClient($wsdl, array('trace' => true,'exceptions' => true ));
				$result = $client->__call('Setup' , array("parameters"=>$params_transaction));
				####  UPDATE TRANSACTION INFO IN DB  ####
			    $sql_orders_status_history = array(
                                        'orders_id' => $insert_id,
                                        'orders_status_id' => $order->info['order_status'],
                                        'date_added' => 'now()',
                                        'customer_notified' => 0,
                                        'comments' =>   'BBS Setup OK '.date("Y-m-d G:i:s").
                                                        ' - BBS TransID: '.$transactionId.
                                                        ' - ZenCart orderID: '.$insert_id);

			    zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);
			        
			    // Save BBS-data to order table
			    $sql_orders_array = array('bbs_trans_id' =>  $transactionId,
	                                'bbs_setup_transaction_string' => $result->SetupResult);
			    zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "orders_id='".$insert_id."'");
			    ####  END UPDATE TRANSACTION INFO IN DB  ####
			        
			    $_SESSION['bbs_setup_transaction_string'] = $result->SetupResult;
			        
			    zen_redirect(HTTP_SERVER.DIR_WS_CATALOG.'checkout_redirect_netaxept_bbs.php?terminal_location='
                                        .MODULE_PAYMENT_BBS_NETAXEPT_TERMINALLOCATION.'&transactionId='.$transactionId);
			}
			catch (SoapFault $fault) 
			{
				#####  ERROR HANDLING SETUP ######
                ####  UPDATE TRANSACTION INFO IN DB  ####
                // Change order status
                $sql_orders_array = array('orders_status' =>  98);
		        zen_db_perform(TABLE_ORDERS, $sql_orders_array, 'update', "orders_id='".$insert_id."'");
                                
                // Add status to history table
                $sql_orders_status_history = array('orders_id' => $insert_id,
                	'orders_status_id' => 98,
                    'date_added' => 'now()',
                    'customer_notified' => 0,
                    'comments' => 'BBS Setup FAILED '.date("Y-m-d G:i:s"). ' Fault: '.$fault->faultstring);
                                                                     
                zen_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_orders_status_history);   
                echo $fault->faultstring;
                ####  END UPDATE TRANSACTION INFO IN DB  ####
                //tep_redirect(HTTP_SERVER.DIR_WS_HTTP_CATALOG.'checkout_error_netaxept_bbs.php?error_type='.$error_type.'&message='.$fault->faultstring);        
			}
			######  END ERROR HANDLING  ######
			####  END SETUP  ####
		} // END if
		return $ret;
	}  // END AFTER PROCESS

########

    function get_error() {
       	return false;
    }

    function check() {
    	global $db;
        if (!isset($this->_check)) {
        	$my_result = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_BBS_NETAXEPT_STATUS'");
        	$this->_check = $my_result->RecordCount();
      	}
      	return $this->_check;
    }


	function install() {
        global $db;
          // Netaxept configuration parameters, edit using the Admin GUI
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
        values (
                'Activate BBS Netaxept Payment Module',
                'MODULE_PAYMENT_BBS_NETAXEPT_STATUS',
                'True',
                'Activate module?',
                '6',
                '1',
                'zen_cfg_select_option(array(\'True\', \'False\'), ',
                now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
        values (
                'Netaxept Auth or Sale',
                'MODULE_PAYMENT_BBS_NETAXEPT_AUTHSALE',
                'auth',
                'Do a Netaxept Auth or Sale on order, used to do an auth (reserve the amount on the card) or sale (capture the amount from the card).',
                '6',
                '3',
                'zen_cfg_select_option(array(\'auth\', \'sale\'), ', now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
        values (
                'Send customer confirmation email',
                'MODULE_PAYMENT_BBS_NETAXEPT_EMAIL',
                'yes',
                'Send a confirmation email to the customer.',
                '6',
                '3',
                'zen_cfg_select_option(array(\'yes\', \'no\'), ', now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'Netaxept Merchant ID',
                'MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID',
                '123456',
                'The merchant id you have received from Netaxept',
                '6',
                '4',
                now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'Token',
                'MODULE_PAYMENT_BBS_NETAXEPT_TOKEN',
                '1234567890',
                'The token you have received from Netaxept',
                '6',
                '5',
                now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'Language',
                'MODULE_PAYMENT_BBS_NETAXEPT_LANGUAGE',
                'en_GB',
                'Language code for language at Netaxept site (5 character language code, e.g. en_GB)',
                '6',
                '6',
                now());");

        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
        values (
                'Terminal location',
                'MODULE_PAYMENT_BBS_NETAXEPT_TERMINALLOCATION',
                'https://epayment-test.bbs.no/terminal/',
                'Terminal to use?',
                '6',
                '7',
                'zen_cfg_select_option(array(\'https://epayment-test.bbs.no/terminal/\', \'https://epayment.bbs.no/terminal/\'), ', now());");
                
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
		values (
	        'WSDL location',
	        'MODULE_PAYMENT_BBS_NETAXEPT_WSDLLOCATION',
	        'https://epayment-test.bbs.no/service.svc?wsdl',
	        'WSDL to use?',
	        '6',
	        '7',
	        'zen_cfg_select_option(array(\'https://epayment-test.bbs.no/service.svc?wsdl\', \'https://epayment.bbs.no/service.svc?wsdl\'), ', now())");

        
        

       $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
       values (
                'BBS Netaxept sort order',
                'MODULE_PAYMENT_BBS_NETAXEPT_SORT_ORDER',
                '0',
                'BBS Netaxept sort order',
                '6',
                '8',
                now());");

       $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'BBS Netaxept Zone',
                'MODULE_PAYMENT_BBS_NETAXEPT_ZONE',
                '0',
                'BBS Netaxept Zone',
                '6',
                '9',
                now());");


        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added)
        values (
                'Order status',
                'MODULE_PAYMENT_BBS_NETAXEPT_ORDER_STATUS_ID',
                '0',
                'Set order status',
                '6',
                '0',
                'zen_cfg_pull_down_order_statuses(',
                'zen_get_order_status_name',
                now());");
        
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'BBS Netaxept Error message',
                'MODULE_PAYMENT_BBS_NETAXEPT_ERROR_MESSAGE',
                'An error occured when processing the payment. Please contact the webshop to get help. <br/><br/>OrderId: ',
                'Error message displayed when an error occurs',
                '6',
                '9',
                now());");
        
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added)
        values (
                'BBS Netaxept Cancel message',
                'MODULE_PAYMENT_BBS_NETAXEPT_CANCEL_MESSAGE',
                'You canceled the payment process. Payment aborted.',
                'Message displayed when a cancel occurs',
                '6',
                '9',
                now());");
        
        $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added)
        values (
                'Debug mode',
                'MODULE_PAYMENT_BBS_NETAXEPT_DEBUG',
                'Normal',
                'Debug mode on Netaxept checkout success page?',
                '6',
                '7',
                'zen_cfg_select_option(array(\'Normal\', \'Debug\'), ', now());");

	}


	function remove() {
		global $db;
        $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
	}

	function keys() {
		return array(
		'MODULE_PAYMENT_BBS_NETAXEPT_STATUS',
		'MODULE_PAYMENT_BBS_NETAXEPT_AUTHSALE',
		'MODULE_PAYMENT_BBS_NETAXEPT_MERCHANTID',
		'MODULE_PAYMENT_BBS_NETAXEPT_TOKEN',
		'MODULE_PAYMENT_BBS_NETAXEPT_LANGUAGE',
		'MODULE_PAYMENT_BBS_NETAXEPT_ORDER_STATUS_ID',
		'MODULE_PAYMENT_BBS_NETAXEPT_ZONE',
		'MODULE_PAYMENT_BBS_NETAXEPT_SORT_ORDER',
		'MODULE_PAYMENT_BBS_NETAXEPT_TERMINALLOCATION',
		'MODULE_PAYMENT_BBS_NETAXEPT_WSDLLOCATION',
		'MODULE_PAYMENT_BBS_NETAXEPT_EMAIL',
		'MODULE_PAYMENT_BBS_NETAXEPT_ERROR_MESSAGE',
		'MODULE_PAYMENT_BBS_NETAXEPT_CANCEL_MESSAGE',
		'MODULE_PAYMENT_BBS_NETAXEPT_DEBUG');
	}
} //  END CLASS
?>